(** RISC-V instructions *)

open Register

type arg = Cte of int (** immediate value *)
         | Reg of reg (** register or pseudo-register *)

type label = string (** RTL graph labels *)             

type rtl_node = {
    label : label; (** entry label *)
    op : string; (** name of the RISC-V operator *)
    dest : reg option; (** destination register, if present *)
    args : arg list; (** arguments *)
    exits : label list; (** exit labels *)
}
              
type rtl = rtl_node list

type riscv = rtl_node

(** printing function for a RISC-V instruction *)
val print_riscv : out_channel -> rtl_node -> unit
  
